#!/bin/sh
###
# Copyright (C) 2016 Serg A. Kotlyarov <shadowsbrother@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

i=`ls -fd -1 /tmp/* 2>/dev/null|grep "^/tmp.*.tmp.hcl-get$"`
[[ ! $i || -d $i || `echo "$i"|wc -l` != 1 ]] && exit 0
b=`basename $i`
t=${b%.*}
d="`cat $i`/tmp/${t%.*}"
rm -f $i
a=hcl-get.tar
r=$d/$a
f=frequency
h=hwinfo
l="echo -n ."
s=system-report
e() {
echo error > $d/$1.err
exit 0
}
s() {
$s -o $1 2&>/var/log/$s.log
}
echo -n $'\n'"Сбор информации о системе"
$l
v=`rpm -q --queryformat=%{VERSION} $s`
w=${v%.*}
if [[ ${w##*.} == 0 && ${v##*.} < 9 ]]; then
 s $r.bz2
 p=$r.bz2
else
 s $r
 for x in xz bz2 gz; do
  [[ -s $r.$x ]] && p=$r.$x
 done
fi
[[ $p || -s $p ]] || e $s
$l
if [[ ! `cat /proc/cpuinfo|grep '^model name.*[0-9][.0-9]*[GM]Hz$'` ]]; then
 dmidecode -s processor-$f > $d/$f
 [ -s $d/$f ] || e $f
fi
$l
$h > $d/$h
[ -s $d/$h ] || e $h
$l
echo
exit 0
